using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using J4L.TextPrinter;
using J4L.TextPrinter.Ports;
using J4L.TextPrinter.Printers;



	/// <summary>
	/// Description of ExamplesFrm.
	/// </summary>
	public class ExamplesFrm : System.Windows.Forms.Form
	{
		
   		WindowsPrinter port;
   		TextPrinter printer;
		
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.ComboBox comboBox2;
		private System.Windows.Forms.Button btnPrint;
		public ExamplesFrm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			
			string[] printers=PrinterFactory.getSupportedPrinters();
			for (int i=0;i<printers.GetLength(0);i++)
          		comboBox1.Items.Add(printers[i]);			
			
			comboBox1.SelectedIndex=0;
			comboBox2.SelectedIndex=0;
			textBox1.Text="MyPrinterName";

		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnPrint = new System.Windows.Forms.Button();
			this.comboBox2 = new System.Windows.Forms.ComboBox();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.btnQuit = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(72, 144);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.TabIndex = 6;
			this.btnPrint.Text = "Print";
			this.btnPrint.Click += new System.EventHandler(this.BtnPrintClick);
			// 
			// comboBox2
			// 
			this.comboBox2.Items.AddRange(new object[] {
						"Print Purchase Order report",
						"Print Test Character Pitch",
						"Print Test Line spacing",
						"Print Test Character set",
						"Print Test Lines",
						"Print Test Font Styles",
						"Print Test Proportional Fonts",
						"Print Test Fonts"});
			this.comboBox2.Location = new System.Drawing.Point(112, 88);
			this.comboBox2.Name = "comboBox2";
			this.comboBox2.Size = new System.Drawing.Size(256, 21);
			this.comboBox2.TabIndex = 5;
			this.comboBox2.Text = "comboExample";
			this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.ComboBox2SelectedIndexChanged);
			// 
			// comboBox1
			// 
			this.comboBox1.Location = new System.Drawing.Point(112, 56);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(256, 21);
			this.comboBox1.TabIndex = 4;
			this.comboBox1.Text = "comboType";
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(208, 144);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.TabIndex = 7;
			this.btnQuit.Text = "Quit";
			this.btnQuit.Click += new System.EventHandler(this.BtnQuitClick);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(112, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "txtPrinter";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Printer";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 23);
			this.label2.TabIndex = 2;
			this.label2.Text = "Type";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 96);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 23);
			this.label3.TabIndex = 3;
			this.label3.Text = "Example";
			// 
			// ExamplesFrm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 190);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.comboBox2);
			this.Controls.Add(this.comboBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label1);
			this.Name = "ExamplesFrm";
			this.Text = "Examples";
			
			this.ResumeLayout(false);
		}
		#endregion
		void ComboBox2SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
		}


		
		void BtnPrintClick(object sender, System.EventArgs e)
		{
 try {

       this.port=new WindowsPrinter(textBox1.Text);


      this.printer=PrinterFactory.getPrinter((String) this.comboBox1.SelectedItem);
	  printer.debug=true;
      if (comboBox2.SelectedIndex==0) this.order();
      if (comboBox2.SelectedIndex==1) this.pitch();
      if (comboBox2.SelectedIndex==2) this.interspacing();
      if (comboBox2.SelectedIndex==3) this.charset();
      if (comboBox2.SelectedIndex==4) this.lines();
      if (comboBox2.SelectedIndex==5) this.fontStyle();
      if (comboBox2.SelectedIndex==6) this.proportionalFont();
      if (comboBox2.SelectedIndex==7) this.fonts();


    } catch (Exception ex) {
    		Console.WriteLine(ex.Message);
    		//Console.WriteLine(ex.StackTrace);
    }			
		}
		
		void BtnQuitClick(object sender, System.EventArgs e)
		{
			this.Hide();
		}
	
		
/**
    * test characters set conversion
    */
   public void order() {

    try {
      JobProperties job= printer.getDefaultJobProperties();

      printer.startJob(port,job);

      job.pitch=12;

      TextProperties prop=printer.getDefaultTextProperties();
      TextProperties propBold=printer.getDefaultTextProperties();
      propBold.bold=true;
      TextProperties propItalic=printer.getDefaultTextProperties();
      propItalic.italic=true;

      // Order header
      printer.printString("Purchase Order", 3,9,propBold);

      printer.printString("High", 7,21,prop);
      printer.printString("London", 7,41,prop);
      printer.printString("Elmfield Road 3", 6,41,prop);
      printer.printString("Company1", 5,41,prop);
      printer.printString("X", 8,21,prop);
      printer.printString("13/00/1999",6, 21,prop);
      printer.printString("O109Bis", 5,21,prop);
      printer.printString("Approved", 8,9,prop);
      printer.printString("Priority", 7,9,prop);
      printer.printString("Number", 5,9,prop);
      printer.printString("Date", 6,9,prop);


      // detail header
      printer.printString("Priority",12, 38,propBold);
      printer.printString("Amount",12, 64,propBold);
      printer.printString("Price",12, 58,propBold);
      printer.printString("Quantity",12, 48,propBold);
      printer.printString("Description",12, 20,propBold);
      printer.printString("Article",12, 10,propBold);

      // frame
      printer.printRectangle(8,11,71,31);
      printer.printHorizontalLine(13,8,71);

      // line 1
      printer.printString("Low",14, 41,prop);
      printer.printString("300",14, 65,prop);
      printer.printString("1",14, 58,prop);
      printer.printString("300",14, 50,prop);
      printer.printString("123456789012345678",14, 22,prop);
      printer.printString("A0301",14, 9,prop);

      // line 2
      printer.printString("Low",16, 41,prop);
      printer.printString("200",16, 65,prop);
      printer.printString("1",16, 58,prop);
      printer.printString("200",16, 50,prop);
      printer.printString("CD-ROM writer",16, 22,prop);
      printer.printString("B0301",16, 9,prop);

      // line 3
      printer.printString("Medium",18, 41,prop);
      printer.printString("330",18, 65,prop);
      printer.printString("1",18, 58,prop);
      printer.printString("330",18, 50,prop);
      printer.printString("Laptop SP",18, 22,prop);
      printer.printString("C0405",18, 9,prop);


      // total
      printer.printString("830",32, 65,prop);
      printer.printString("Total",32, 58,prop);

      // page footer
      printer.printString("Page 1", 56,65,propItalic);

      printer.endJob();
    } catch (Exception e) {
    		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

   /**
    * test characters set conversion
    */
   public void charset() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.autoChartSetSelection=true;
      job.topMargin=3;
      printer.startJob(port,job);
      //job.topMargin=5;


      printer.printString("Trying to print some characters that require a symbol set change: ");
      printer.newLine();
      printer.printString("Accents:          ");
      printer.newLine();
      printer.printString("Diaeresis:     ");
      printer.newLine();

      printer.endJob();
    } catch (Exception e) {
    		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

   /**
    * test proportional fonts
    */
  public void proportionalFont() {

    try {
     JobProperties job= printer.getDefaultJobProperties();
     job.proportional=true;

     printer.calculatePitchAndHMI=true;
      job.paperSize=PaperSize.A4;
      job.cols=80;
      printer.startJob(port,job);



      TextProperties p=printer.getDefaultTextProperties();
 // t.fontName="Letter Gothic";
      p.proportional=true;
      printer.printString("Proportional characters test 0",9,0,p);
      printer.printString("Print at line 10 column 0",10,0,p);
      printer.printString("Print at line 11 column 20",11,20,p);
      printer.printString("Print at line 12 column 40",12,40,p);
      printer.printString("Print at line 13 column 60",13,60,p);

     TextProperties t=printer.getDefaultTextProperties();
      t.proportional=false;
     // t.fontName="Letter Gothic";
      printer.printString("Fixed Characters test",19,0,t);
      printer.printString("Print at line 20 column 0",20,0,t);
      printer.printString("Print at line 21 column 20",21,20,t);
      printer.printString("Print at line 22 column 40",22,40,t);
      printer.printString("Print at line 23 column 60",23,60,t);

      printer.endJob();
    } catch (Exception e) {
    		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }


   /**
    * test line drawing
    */
   public void lines() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      printer.startJob(port,job);

      printer.printRectangle(10,10,60,50);
      printer.printHorizontalLine(15,10,60);
      printer.printVerticalLine(35,10,50);

      printer.endJob();
    } catch (Exception e) {
          		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

   /**
    * test line spacing
    */
   public void interspacing() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      job.interspacing="1/8";

      printer.startJob(port,job);

      printer.printString("This is a 1/8 line spacing example. The following 8 lines will be take 1 inch");
      printer.newLine();
      for (int i=0;i<8;i++) {
          printer.printString("Line "+i);
          printer.newLine();
      }

      printer.endJob();
    } catch (Exception e) {
    		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

    /**
    * test character size
    */
   public void pitch() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      job.pitch=12;

      printer.startJob(port,job);

      printer.printString("This is a pitch (font size) example ( 12 characters per inch):");
      printer.newLine();
      printer.printString("123456789012");
      printer.newLine();

      TextProperties t=printer.getDefaultTextProperties();
      t.pitch=10;
      printer.printString("This is a pitch (font size) example ( 10 characters per inch):");
      printer.newLine();
      printer.printString("123456789012",t);

      printer.endJob();
    } catch (Exception e) {
    		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

   /**
    * test fonts
    */
  public void fonts() {

    try {
     JobProperties job= printer.getDefaultJobProperties();
     job.proportional=true;

      job.paperSize=PaperSize.A4;
      job.cols=80;
      printer.startJob(port,job);

      String font1="Courier";
      String font2="Roman";
      int i=0;
      IDictionaryEnumerator e=printer.getSupportedFonts();
      while ((e.MoveNext()) && (i<2)) {
          i++;
          if (i==1) font1=(String) e.Value;
          if (i==2) font2=(String) e.Value;
      }

      TextProperties p=printer.getDefaultTextProperties();
      p.fontName=font1;
      p.proportional=true;
      printer.printString("This should be "+ font1 + " font",p);


     TextProperties t=printer.getDefaultTextProperties();
      p.fontName=font2;
      p.proportional=true;
      printer.printString("This should be " + font2 + " font",p);

      printer.endJob();
    } catch (Exception e) {
       		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }
   }

    /**
    * test font style
    */
  public void fontStyle() {

    try {

      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      printer.startJob(port,job);
      // NORMAL
      TextProperties prop=new TextProperties();
      printer.printString("This must be NORMAL",prop);
      printer.newLine();

      // BOLD
      prop=new TextProperties();
      prop.bold=true;
      printer.printString("This must be BOLD",prop);
      printer.newLine();

      // ITALIC
      prop=new TextProperties();
      prop.italic=true;
      printer.printString("This must be ITALIC",prop);
      printer.newLine();

      // underlined
      prop=new TextProperties();
      prop.underlined=true;
      printer.printString("This must be UNDERLINED",prop);
      printer.newLine();

      // double wide
      prop=new TextProperties();
      prop.doubleWide=true;
      printer.printString("This must be double wide",prop);
      printer.newLine();

      // double strike
      prop=new TextProperties();
      prop.doubleStrike=true;
      printer.printString("This must be double strike",prop);
      printer.newLine();

      // subscript
      prop=new TextProperties();
      prop.subscript=true;
      printer.printString("This must be subscript",prop);
      printer.newLine();

      // superscript
      prop=new TextProperties();
      prop.superscript=true;
      printer.printString("This must be superscript",prop);
      printer.newLine();

      printer.endJob();

    } catch (Exception e) {
          		Console.WriteLine(e.Message);
    		Console.WriteLine(e.StackTrace);
    }

  }		

    
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new ExamplesFrm());
		}    
    
}
